#pragma once

class Animal {
public:
    double _weight;
    Animal(double w) : _weight(w) {}
    virtual bool is_Lion() const     { return false; }
    virtual bool is_Rhino() const    { return false; }
    virtual bool is_Elephant() const { return false; }
};

class Lion : public Animal {
public:
    bool _male;
    Lion(double w, bool l) : Animal(w), _male(l) {}
    virtual bool is_Lion() const     { return true; }
};

class Rhino : public Animal {
public:
    double _horn;
    Rhino(double w, double h) : Animal(w), _horn(h) {}
    virtual bool is_Rhino() const    { return true; }
};

class Elephant : public Animal {
public:
    double _lefttusk, _righttusk;
    Elephant(double w, double lt, double rt) : Animal(w), _lefttusk(lt), _righttusk(rt) {}
    virtual bool is_Elephant() const { return true; }
};
