#pragma once

#include <vector>
#include <string>

#include "trophy.h"

class Hunter {
public:
    std::string _name;
    int _age;
    std::vector<Trophy*> _trophies;

    Hunter(const std::string &n, int a) : _name(n), _age(a) {}

    int countMaleLions() const;
    void shoot(const std::string &place, const std::string &date, Animal* animal)
    {
        _trophies.push_back(new Trophy(place, date, animal));
    }
};


